/*
  hostdef.h - e-paper Host Interface Define's

  Copyright (c) 2022 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/
#pragma once

#include <stdint.h>

#ifndef EPD_BRIDGE
#define EPD_BRIDGE JN516x::ADDR_OTA_BRIDGE2
#endif

#ifndef EPD_ADDRESS
#define EPD_ADDRESS 1
#endif

#ifndef EPD_PANID
#define EPD_PANID 0xEDED
#endif

#ifndef EPD_CHANNEL
#define EPD_CHANNEL WPan::CHANNEL_25
#endif

#ifndef EPD_TIMEOUT
#define EPD_TIMEOUT 1000000
#endif

enum
{
  EPD_QUERY_PAINT = 0x10,
  EPD_BEGIN_PAINT = 0x11,
  EPD_IMAGE_DATA  = 0x12,
  EPD_END_PAINT   = 0x13,
  EPD_REFRESH     = 0x14,
};

enum
{
  EPD_COLOR_BLACK = 0,
  EPD_COLOR_WHITE = 1,
  EPD_COLOR_RED   = 2,
  EPD_COLOR_MAX   = 3,
};

typedef struct __attribute__((packed))
{
  uint8_t command;
  union
  {
    uint8_t data[96];
    uint8_t status;
    uint8_t color;
    struct __attribute__((packed))
    {
      uint8_t  status;
      uint8_t  reserve[2];
      uint32_t interval;
    } query;
  } args;
  uint8_t csum;
} command_t;

