#!/bin/sh

INSTALL_DIR=$(cd $(dirname $0) && pwd)

PROGRAM_NAME=nameplate
PROGRAM_PATH=${INSTALL_DIR}/${PROGRAM_NAME}
PROGRAM_OPTS=
SERVICE_NAME=${PROGRAM_NAME}
SERVICE_PATH=/etc/systemd/system/${SERVICE_NAME}.service

echo "#!/bin/sh" >${PROGRAM_PATH}.sh
echo >>${PROGRAM_PATH}.sh
echo "if [ -c /dev/ttyUSB0 ]; then" >>${PROGRAM_PATH}.sh
echo "  ${PROGRAM_PATH} -device ttyUSB0 ${PROGRAM_OPTS}" >>${PROGRAM_PATH}.sh
echo "elif [ -c /dev/ttyUSB1 ]; then" >>${PROGRAM_PATH}.sh
echo "  ${PROGRAM_PATH} -device ttyUSB1 ${PROGRAM_OPTS}" >>${PROGRAM_PATH}.sh
echo "fi" >>${PROGRAM_PATH}.sh
chmod +x ${PROGRAM_PATH}.sh

if [ -f ${SERVICE_PATH} ]; then
  systemctl stop ${SERVICE_NAME}
  systemctl disable ${SERVICE_NAME}
fi

echo "[Unit]" >${SERVICE_PATH}
echo "Description = House Name Plate" >>${SERVICE_PATH}
echo "After=multi-user.target" >>${SERVICE_PATH}
echo "ConditionPathExists=${INSTALL_DIR}" >>${SERVICE_PATH}
echo >>${SERVICE_PATH}
echo "[Service]" >>${SERVICE_PATH}
echo "WorkingDirectory=${INSTALL_DIR}" >> ${SERVICE_PATH}
echo "ExecStart=${PROGRAM_PATH}.sh" >>${SERVICE_PATH}
echo "Restart=always" >>${SERVICE_PATH}
echo "Type=simple" >>${SERVICE_PATH}
echo >>${SERVICE_PATH}
echo "[Install]" >>${SERVICE_PATH}
echo "WantedBy=multi-user.target" >>${SERVICE_PATH}

systemctl daemon-reload
systemctl enable ${SERVICE_NAME}
systemctl start ${SERVICE_NAME}

